diff -Nur blog.old/js/ui/plogui.js blog.new/js/ui/plogui.js
--- blog.old/js/ui/plogui.js	2006-12-03 13:16:33.129889000 +0800
+++ blog.new/js/ui/plogui.js	2006-12-03 13:18:56.140485000 +0800
@@ -117,7 +117,7 @@
 	if ( $('optionPanel').style.display == 'none' )
 	{
 		startWidth = $('mainPanel').offsetWidth;
-		new Rico.Effect.Size( $('mainPanel'), 489, null, 500, 10, {
+		new Rico.Effect.Size( $('mainPanel'), 626, null, 500, 10, {
 			complete:function() { 
 				Element.show($('optionPanel'));
 				$('optionIconLink').innerHTML = msgHideOptionPanel;
@@ -128,7 +128,7 @@
 	{
 		Element.hide($('optionPanel'));
 		startWidth = $('mainPanel').offsetWidth;
-		new Rico.Effect.Size( $('mainPanel'), 660, null, 500, 10, {
+		new Rico.Effect.Size( $('mainPanel'), 860, null, 500, 10, {
 			complete:function() { 
 				$('optionIconLink').innerHTML = msgShowOptionPanel;
 				$('optionIconLink').title = msgShowOptionPanel;
diff -Nur blog.old/styles/admin-ff.css blog.new/styles/admin-ff.css
--- blog.old/styles/admin-ff.css	2006-07-05 05:21:02.000000000 +0800
+++ blog.new/styles/admin-ff.css	2006-12-03 13:47:30.742329269 +0800
@@ -7,12 +7,12 @@
     padding          : 0px;
     text-align       : center;
     font             : 12px verdana, tahoma, arial, sans-serif;
-    background       : #EEEEEE url("../imgs/bg_main.jpg") repeat-y center;
+    background       : #EEEEEE url("../imgs/bg_main1024.jpg") repeat-y center;
 }
 
 #container
 {
-    width            : 786px;
+    width            : 1010px;
     text-align       : left;
     margin-left      : auto;
     margin-right     : auto;
@@ -29,7 +29,7 @@
 
 #header #blogLink
 {
-    float: left;    width : 783px;    height: 52px;
+    float: left;    width : 1007px;    height: 52px;
     margin-top: 5px;}
 
 #header span
@@ -479,7 +479,7 @@
     font-size        : 0.93em;
     padding          : 0px;
     margin           : 0px;
-    height           : 60px;
+    height           : 80px;
 }
 
 #list_nav_select
@@ -525,7 +525,7 @@
     margin-left      : auto;
     margin-right     : auto;
     margin-bottom    : 10px;
-    width            : 775px;
+    width            : 999px;
     border-collapse  : collapse;
     border-bottom    : 4px solid #DEDEDE;
     border-spacing   : 0px;
@@ -607,7 +607,7 @@
 {
     margin-left      : auto;
     margin-right     : auto;
-    width            : 768px;
+    width            : 992px;
     padding          : 4px;
     text-align       : right;
     /*background-color : #F3F1FF;*/
diff -Nur blog.old/styles/admin-rtl.css blog.new/styles/admin-rtl.css
--- blog.old/styles/admin-rtl.css	2006-07-05 05:21:02.000000000 +0800
+++ blog.new/styles/admin-rtl.css	2006-12-03 13:49:13.035028237 +0800
@@ -7,12 +7,12 @@
     padding          : 0px;
     text-align       : center;
     font             : 12px Tahoma;
-    background       : #EEEEEE url("../imgs/bg_main.jpg") repeat-y center;
+    background       : #EEEEEE url("../imgs/bg_main1024.jpg") repeat-y center;
 }
 
 #container
 {
-    width            : 786px;
+    width            : 1010px;
     text-align       : right;
     margin-left      : auto;
     margin-right     : auto;
@@ -29,7 +29,7 @@
 
 #header #blogLink
 {
-    float: left;    width : 783px;    height: 52px;
+    float: left;    width : 1007px;    height: 52px;
     margin-top: 5px;}
 
 #header span
@@ -475,7 +475,7 @@
     font-size        : 0.90em;
     padding          : 0px;
     margin           : 0px;
-    height           : 60px;
+    height           : 80px;
 }
 
 #list_nav_select
@@ -521,7 +521,7 @@
     margin-left      : auto;
     margin-right     : auto;
     margin-bottom    : 10px;
-    width            : 775px;
+    width            : 999px;
     border-collapse  : collapse;
     border-bottom    : 4px solid #DEDEDE;
     border-spacing   : 0px;
@@ -603,7 +603,7 @@
 {
     margin-left      : auto;
     margin-right     : auto;
-    width            : 768px;
+    width            : 992px;
     padding          : 4px;
     text-align       : left;
     /*background-color : #F3F1FF;*/
diff -Nur blog.old/styles/admin.css blog.new/styles/admin.css
--- blog.old/styles/admin.css	2006-09-07 15:42:52.000000000 +0800
+++ blog.new/styles/admin.css	2006-12-03 13:23:28.028965000 +0800
@@ -7,12 +7,12 @@
     padding          : 0px;
     text-align       : center;
     font             : 12px verdana, tahoma, arial, sans-serif;
-    background       : #EEEEEE url("../imgs/bg_main.jpg") repeat-y center;
+    background       : #EEEEEE url("../imgs/bg_main1024.jpg") repeat-y center;
 }
 
 #container
 {
-    width            : 786px;
+    width            : 1010px;
     text-align       : left;
     margin-left      : auto;
     margin-right     : auto;
@@ -30,7 +30,7 @@
 #header #blogLink
 {
     float: left;
-    width : 786px;
+    width : 1010px;
     height: 58px;
     margin-top: 2px;
 }
@@ -531,7 +531,7 @@
     font-size        : 0.90em;
     padding          : 0px;
     margin           : 0px;
-    height           : 60px;
+    height           : 80px;
 }
 
 #list_nav_select
@@ -577,7 +577,7 @@
     margin-left      : auto;
     margin-right     : auto;
     margin-bottom    : 10px;
-    width            : 775px;
+    width            : 999px;
     border-collapse  : collapse;
     border-bottom    : 4px solid #DEDEDE;
     border-spacing   : 0px;
@@ -659,7 +659,7 @@
 {
     margin-left      : auto;
     margin-right     : auto;
-    width            : 768px;
+    width            : 992px;
     padding          : 4px;
     text-align       : right;
     /*background-color : #F3F1FF;*/
diff -Nur blog.old/templates/admin/statistics.template blog.new/templates/admin/statistics.template
--- blog.old/templates/admin/statistics.template	2006-08-16 18:41:50.000000000 +0800
+++ blog.new/templates/admin/statistics.template	2006-12-03 13:35:03.724550000 +0800
@@ -8,10 +8,10 @@
                 <thead>
                     <tr>
                         <th style="width:10px;"><input class="checkbox" type="checkbox" name="all" id="all" value="1" onclick="toggleAllChecks('postStats');" /></th>
-                        <th style="width:500px;">{$locale->tr("referrer")}</th>                        
+                        <th style="width:669px;">{$locale->tr("referrer")}</th>                        
 						<th style="width:70px;">{$locale->tr("hits")}</th>
-                        <th style="width:100px;">{$locale->tr("date")}</th>
-                        <th style="width:95px;">{$locale->tr("actions")}</th>
+                        <th style="width:180px;">{$locale->tr("date")}</th>
+                        <th style="width:70px;">{$locale->tr("actions")}</th>
                     </tr>
                 </thead>
                 <tbody>